Race condition in RepositoryVersion.new_version()
01/14/2020 02:01 PM - osapryki
Description

If "RepositoryVersion.new_version" is executed at the same time in two parallel transactions, one of transactions may fail with unique
constraint error:

duplicate key value violates unique constraint "pulp_app_repositoryversion_repository_id_number_ 07
cb5788_unig" DETAIL: Key (repository_id, number)=(1, 735) already exists.

This is caused because of race condition possible in "RepositoryVersion.new_version()" call:

SELECT last_version FROM pulp_app_repository WHERE id = 1
last_version

TRANSACTION 1 TRANSACTION 2

INSERT INTO pulp_app_repositoryversion

(repository_id, number) VALUES (1, 22)

# NOTE: number = int (self.last_version) + 1;

UPDATE pulp_app_repository

SET last_version = 22;
INSERT INTO pulp_app_repositoryversion
(repository_id, number) VALUES (1, 22)
# NOTE: number = int (self.last_version) + 1;
UPDATE pulp_app_repository
SET last_version = 22;

COMMIT;

# NOTE: OK
COMMIT;
# NOTE: uplicate key value violates unique
# constraint

Solution:

You should lock repository record to perform “last_version’ increment and update (e.g. do SELECT FOR UPDATE before
incrementing last_version counter and creating a new version).

History

#1 - 01/14/2020 04:17 PM - bmbouter

| want to share some info on Pulp's tasking system. Pulp's tasking system provides a serialization of tasks based on locks. In the case of
new_version, e.g. it's typically called from add_and_remove here. That is dispatched with the lock on repository itself second param here which
causes add_and_remove operations to be serialized.

Improving the code to have fewer race conditions sounds good though, especially if plugin writers want to create new versions in the viewset. Do
plugins want to create new_version in the viewsets?

#2 - 01/14/2020 04:35 PM - fao89

- Triaged changed from No to Yes

#3 - 10/09/2020 04:03 PM - dkliban@redhat.com
- Status changed from NEW to CLOSED - WORKSFORME

Repository Versions should be created inside of tasks so that the work is serialized.
https://github.com/pulp/pulpcore/blob/50cab88e17eb5e31b47ef30e214aa1973261559f/pulpcore/app/tasks/repository.py#L97-L99
https://github.com/pulp/pulpcore/blob/b94abcea602712c7610595078a3d26a2029725e1/pulpcore/plugin/actions.py#L54
http://www.tcpdf.org

